"use strict";
var specialOptionKeys = ["parent", "style", "dataset"];
function html(tag, classList, options) {
    if (options == null) {
        if (typeof classList === "object" && !Array.isArray(classList)) {
            options = classList;
            classList = null;
        }
        else {
            options = {};
        }
    }
    if (typeof classList === "string")
        classList = [classList];
    var elt = document.createElement(tag);
    if (classList != null) {
        // NOTE: `elt.classList.add.apply(elt, classList);`
        // throws IllegalInvocationException at least in Chrome
        for (var _i = 0, _a = classList; _i < _a.length; _i++) {
            var name_1 = _a[_i];
            elt.classList.add(name_1);
        }
    }
    for (var key in options) {
        if (specialOptionKeys.indexOf(key) !== -1)
            continue;
        var value = options[key];
        elt[key] = value;
    }
    if (options.parent != null)
        options.parent.appendChild(elt);
    if (options.style != null)
        for (var key in options.style)
            elt.style[key] = options.style[key];
    if (options.dataset != null)
        for (var key in options.dataset)
            elt.dataset[key] = options.dataset[key];
    return elt;
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = html;
