"use strict";
var async = require("async");
document.addEventListener("keydown", function (event) {
    // F12
    if (event.keyCode === 123)
        SupApp.getCurrentWindow().webContents.toggleDevTools();
});
var socket;
SupApp.onMessage("build", function (buildSetup) {
    socket = SupClient.connect(SupClient.query.project);
    socket.on("welcome", function (clientId, config) {
        loadPlugins(buildSetup, function () {
            var buildPlugin = SupClient.getPlugins("build")[buildSetup.buildPluginName];
            buildPlugin.content.build(socket, buildSetup.settings, config.buildPort);
        });
    });
});
var detailsContainer = document.querySelector(".details");
var toggleDetailsButton = document.querySelector("button.toggle-details");
toggleDetailsButton.addEventListener("click", function () {
    detailsContainer.hidden = !detailsContainer.hidden;
    toggleDetailsButton.textContent = SupClient.i18n.t("build:" + (detailsContainer.hidden ? "showDetails" : "hideDetails"));
    SupApp.getCurrentWindow().setContentSize(SupApp.getCurrentWindow().getContentSize()[0], detailsContainer.hidden ? 150 : 350);
});
function loadPlugins(buildSetup, callback) {
    var i18nFiles = [];
    i18nFiles.push({ root: "/", name: "build" });
    i18nFiles.push({ root: buildSetup.pluginPath, name: "builds" });
    SupClient.fetch("/systems/" + SupCore.system.id + "/plugins.json", "json", function (err, pluginsInfo) {
        SupCore.system.pluginsInfo = pluginsInfo;
        async.parallel([
            function (cb) {
                SupClient.i18n.load(i18nFiles, cb);
            }, function (cb) {
                async.each(pluginsInfo.list, function (pluginName, cb) {
                    var pluginPath = "/systems/" + SupCore.system.id + "/plugins/" + pluginName;
                    SupClient.loadScript(pluginPath + "/bundles/build.js", cb);
                }, cb);
            }
        ], function () {
            document.querySelector("header").textContent = SupClient.i18n.t("builds:" + buildSetup.buildPluginName + ".title");
            callback();
        });
    });
}
