"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var TreeView = require("dnd-tree-view");
var _1 = require("../../tabs/assets/");
var CreateAssetDialog = (function (_super) {
    __extends(CreateAssetDialog, _super);
    function CreateAssetDialog(open, callback) {
        var _this = this;
        _super.call(this, callback);
        this.onTreeViewSelectionChange = function () {
            if (_this.treeView.selectedNodes.length === 0) {
                _this.treeView.addToSelection(_this.treeView.treeRoot.querySelector("li[data-asset-type=\"" + _this.selectedAssetType + "\"]"));
            }
            else {
                _this.selectedAssetType = _this.treeView.selectedNodes[0].dataset["assetType"];
            }
        };
        this.onTreeViewActivate = function () {
            _this.submit();
        };
        SupClient.html("header", { parent: this.formElt, textContent: SupClient.i18n.t("project:treeView.newAsset.title") });
        SupClient.html("div", "group", { parent: this.formElt, textContent: SupClient.i18n.t("project:treeView.newAsset.prompt") });
        // Type
        var treeViewContainer = SupClient.html("div", ["asset-types-tree-view", "group"], {
            parent: this.formElt,
            style: {
                border: "1px solid #aaa",
                overflowY: "auto",
                height: "300px"
            }
        });
        this.treeView = new TreeView(treeViewContainer, { multipleSelection: false });
        this.treeView.treeRoot.style.paddingBottom = "0";
        this.treeView.on("selectionChange", this.onTreeViewSelectionChange);
        this.treeView.on("activate", this.onTreeViewActivate);
        for (var _i = 0, assetTypes_1 = _1.assetTypes; _i < assetTypes_1.length; _i++) {
            var assetType = assetTypes_1[_i];
            var elt = SupClient.html("li", { dataset: { assetType: assetType } });
            this.treeView.append(elt, "item");
            var icon = SupClient.html("img", { parent: elt, src: "", draggable: false });
            icon.src = "/systems/" + SupCore.system.id + "/plugins/" + _1.editorsByAssetType[assetType].pluginPath + "/editors/" + assetType + "/icon.svg";
            SupClient.html("span", { parent: elt, textContent: _1.editorsByAssetType[assetType].title });
        }
        this.treeView.addToSelection(this.treeView.treeRoot.querySelector("li"));
        this.selectedAssetType = _1.assetTypes[0];
        // Name
        var nameGroup = SupClient.html("div", "group", { parent: this.formElt, style: { display: "flex" } });
        this.nameInputElt = SupClient.html("input", {
            parent: nameGroup, placeholder: SupClient.i18n.t("project:treeView.newAsset.placeholder"),
            pattern: SupClient.namePattern, title: SupClient.i18n.t("common:namePatternDescription"),
            style: { flex: "1 1 0" }
        });
        // Auto-open checkbox
        var downElt = SupClient.html("div", { parent: this.formElt, style: { display: "flex", alignItems: "center" } });
        this.openCheckboxElt = SupClient.html("input", {
            parent: downElt, id: "auto-open-checkbox", type: "checkbox",
            checked: open, style: { margin: "0 0.5em 0 0" }
        });
        SupClient.html("label", {
            parent: downElt, textContent: SupClient.i18n.t("project:treeView.newAsset.openAfterCreation"),
            htmlFor: "auto-open-checkbox", style: { flex: "1", margin: "0" }
        });
        // Buttons
        var buttonsElt = SupClient.html("div", "buttons", { parent: downElt });
        var cancelButtonElt = SupClient.html("button", "cancel-button", {
            parent: buttonsElt, type: "button",
            textContent: SupClient.i18n.t("common:actions.cancel")
        });
        cancelButtonElt.addEventListener("click", function (event) { event.preventDefault(); _this.cancel(); });
        this.validateButtonElt = SupClient.html("button", "validate-button", {
            textContent: SupClient.i18n.t("common:actions.create")
        });
        if (navigator.platform === "Win32")
            buttonsElt.insertBefore(this.validateButtonElt, cancelButtonElt);
        else
            buttonsElt.appendChild(this.validateButtonElt);
        this.treeView.treeRoot.focus();
    }
    CreateAssetDialog.prototype.submit = function () {
        _super.prototype.submit.call(this, {
            name: this.nameInputElt.value,
            type: this.selectedAssetType,
            open: this.openCheckboxElt.checked
        });
    };
    return CreateAssetDialog;
}(SupClient.Dialogs.BaseDialog));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = CreateAssetDialog;
