// FIXME: This shouldn't be directly on the client since it comes from a plugin?
"use strict";
var network_1 = require("../network");
var tabs = require("./");
var homeTab;
function setup(tab) {
    homeTab = tab;
}
exports.setup = setup;
function onMessageChat(message) {
    if (homeTab == null)
        return;
    var isHomeTabVisible = homeTab.classList.contains("active");
    if (isHomeTabVisible && !document.hidden)
        return;
    if (!isHomeTabVisible)
        homeTab.classList.add("unread");
    if (localStorage.getItem("superpowers-disable-notifications") != null)
        return;
    function doNotification() {
        var title = SupClient.i18n.t("project:header.notifications.new", { projectName: network_1.manifest.pub.name });
        var notification = new window.Notification(title, { icon: "/images/icon.png", body: message });
        var closeTimeoutId = setTimeout(function () { notification.close(); }, 5000);
        notification.addEventListener("click", function () {
            window.focus();
            tabs.onActivate(homeTab);
            clearTimeout(closeTimeoutId);
            notification.close();
        });
    }
    if (window.Notification.permission === "granted")
        doNotification();
    else if (window.Notification.permission !== "denied") {
        window.Notification.requestPermission(function (status) {
            window.Notification.permission = status;
            if (window.Notification.permission === "granted")
                doNotification();
        });
    }
}
exports.onMessageChat = onMessageChat;
