"use strict";
var utils = require("./utils");
function showRegistry() {
    utils.getRegistry(function (err, registry) {
        if (process != null && process.send != null) {
            process.send({ type: "registry", registry: registry });
        }
        console.log("Core - Latest: v" + registry.core.version + " / Installed: v" + registry.core.localVersion);
        console.log("");
        for (var systemId in registry.systems) {
            var system = registry.systems[systemId];
            var local = system.localVersion != null ? "Installed: v" + system.localVersion : "Not Installed";
            console.log("System \"" + systemId + "\" - Latest: v" + system.version + " / " + local);
            utils.listAvailablePlugins(registry, systemId);
            console.log("");
        }
    });
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = showRegistry;
