"use strict";
var passport = require("passport");
var passport_local_1 = require("passport-local");
var config_1 = require("./config");
// NOTE: The regex must match the pattern and min/max lengths in client/src/login/index.jade
var usernameRegex = /^[A-Za-z0-9_-]{3,20}$/;
passport.serializeUser(function (user, done) { done(null, user.username); });
passport.deserializeUser(function (username, done) { done(null, { username: username }); });
var strategy = new passport_local_1.Strategy(function (username, password, done) {
    if (!usernameRegex.test(username))
        return done(null, false, { message: "invalidUsername" });
    if (config_1.server.password.length > 0 && password !== config_1.server.password)
        return done(null, false, { message: "invalidCredentials" });
    done(null, { username: username });
});
passport.use(strategy);
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = passport;
