"use strict";
var GridHelper = (function () {
    function GridHelper(root, size, step) {
        this.root = root;
        this.setup(size, step);
    }
    GridHelper.prototype.setup = function (size, step) {
        if (this.gridHelper != null) {
            this.root.remove(this.gridHelper);
            this.gridHelper.geometry.dispose();
            this.gridHelper.material.dispose();
        }
        var actualSize = Math.ceil(size / step) * step;
        this.gridHelper = new THREE.GridHelper(actualSize, step);
        this.gridHelper.color1.setRGB(1, 1, 1);
        this.gridHelper.color2.setRGB(1, 1, 1);
        this.gridHelper.material.transparent = true;
        this.gridHelper.material.opacity = 0.25;
        this.root.add(this.gridHelper);
        this.gridHelper.updateMatrixWorld(false);
        return this;
    };
    GridHelper.prototype.setVisible = function (visible) {
        this.gridHelper.visible = visible;
        return this;
    };
    return GridHelper;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = GridHelper;
