"use strict";
var TransformMarker = (function () {
    function TransformMarker(root) {
        var geometry = new THREE.Geometry();
        geometry.vertices.push(new THREE.Vector3(-0.25, 0, 0), new THREE.Vector3(0.25, 0, 0), new THREE.Vector3(0, -0.25, 0), new THREE.Vector3(0, 0.25, 0), new THREE.Vector3(0, 0, -0.25), new THREE.Vector3(0, 0, 0.25));
        this.line = new THREE.LineSegments(geometry, new THREE.LineBasicMaterial({ color: 0xffffff, opacity: 0.25, transparent: true }));
        this.line.layers.set(1);
        root.add(this.line);
        this.line.updateMatrixWorld(false);
    }
    TransformMarker.prototype.move = function (target) {
        this.line.visible = true;
        this.line.position.copy(target.getWorldPosition());
        this.line.quaternion.copy(target.getWorldQuaternion());
        this.line.updateMatrixWorld(false);
        return this;
    };
    TransformMarker.prototype.hide = function () {
        this.line.visible = false;
        return this;
    };
    return TransformMarker;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = TransformMarker;
