(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
"use strict";
var GridHelper = (function () {
    function GridHelper(root, size, step) {
        this.root = root;
        this.setup(size, step);
    }
    GridHelper.prototype.setup = function (size, step) {
        if (this.gridHelper != null) {
            this.root.remove(this.gridHelper);
            this.gridHelper.geometry.dispose();
            this.gridHelper.material.dispose();
        }
        var actualSize = Math.ceil(size / step) * step;
        this.gridHelper = new THREE.GridHelper(actualSize, step);
        this.gridHelper.color1.setRGB(1, 1, 1);
        this.gridHelper.color2.setRGB(1, 1, 1);
        this.gridHelper.material.transparent = true;
        this.gridHelper.material.opacity = 0.25;
        this.root.add(this.gridHelper);
        this.gridHelper.updateMatrixWorld(false);
        return this;
    };
    GridHelper.prototype.setVisible = function (visible) {
        this.gridHelper.visible = visible;
        return this;
    };
    return GridHelper;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = GridHelper;

},{}],2:[function(require,module,exports){
"use strict";
var SelectionBoxRenderer = (function () {
    function SelectionBoxRenderer(root) {
        this.mesh = new THREE.Mesh(new THREE.BoxGeometry(1, 1, 1), new THREE.MeshBasicMaterial({ color: 0x00ffff, side: THREE.BackSide }));
        root.add(this.mesh);
    }
    SelectionBoxRenderer.prototype.setTarget = function (target) {
        this.target = target;
        this.mesh.visible = true;
        this.move();
        this.resize();
        return this;
    };
    SelectionBoxRenderer.prototype.move = function () {
        this.mesh.position.copy(this.target.getWorldPosition());
        this.mesh.quaternion.copy(this.target.getWorldQuaternion());
        this.mesh.updateMatrixWorld(false);
        return this;
    };
    SelectionBoxRenderer.prototype.resize = function () {
        var vec = new THREE.Vector3();
        var box = new THREE.Box3();
        var inverseTargetMatrixWorld = new THREE.Matrix4().compose(this.target.getWorldPosition(), this.target.getWorldQuaternion(), { x: 1, y: 1, z: 1 });
        inverseTargetMatrixWorld.getInverse(inverseTargetMatrixWorld);
        this.target.traverse(function (node) {
            var geometry = node.geometry;
            if (geometry != null) {
                node.updateMatrixWorld(false);
                if (geometry instanceof THREE.Geometry) {
                    var vertices = geometry.vertices;
                    for (var i = 0, il = vertices.length; i < il; i++) {
                        vec.copy(vertices[i]).applyMatrix4(node.matrixWorld).applyMatrix4(inverseTargetMatrixWorld);
                        box.expandByPoint(vec);
                    }
                }
                else if (geometry instanceof THREE.BufferGeometry && geometry.attributes["position"] != null) {
                    var positions = geometry.attributes["position"].array;
                    for (var i = 0, il = positions.length; i < il; i += 3) {
                        vec.set(positions[i], positions[i + 1], positions[i + 2]);
                        vec.applyMatrix4(node.matrixWorld).applyMatrix4(inverseTargetMatrixWorld);
                        box.expandByPoint(vec);
                    }
                }
            }
        });
        var size = box.size();
        var thickness = 0.1;
        this.mesh.scale.copy(size).add(new THREE.Vector3(thickness, thickness, thickness));
        this.mesh.updateMatrixWorld(false);
        return this;
    };
    SelectionBoxRenderer.prototype.hide = function () {
        this.mesh.visible = false;
        return this;
    };
    return SelectionBoxRenderer;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = SelectionBoxRenderer;

},{}],3:[function(require,module,exports){
/**
 * https://github.com/mrdoob/three.js/blob/master/examples/js/controls/TransformControls.js
 * Rewritten in TypeScript and modified by bilou84
 */
"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var TransformGizmos_1 = require("./TransformGizmos");
var ray = new THREE.Raycaster();
var pointerVector = new THREE.Vector2();
var point = new THREE.Vector3();
var offset = new THREE.Vector3();
var rotation = new THREE.Vector3();
var offsetRotation = new THREE.Vector3();
var lookAtMatrix = new THREE.Matrix4();
var eye = new THREE.Vector3();
var tempMatrix = new THREE.Matrix4();
var tempVector = new THREE.Vector3();
var tempQuaternion = new THREE.Quaternion();
var unitX = new THREE.Vector3(1, 0, 0);
var unitY = new THREE.Vector3(0, 1, 0);
var unitZ = new THREE.Vector3(0, 0, 1);
var quaternionXYZ = new THREE.Quaternion();
var quaternionX = new THREE.Quaternion();
var quaternionY = new THREE.Quaternion();
var quaternionZ = new THREE.Quaternion();
var quaternionE = new THREE.Quaternion();
var oldPosition = new THREE.Vector3();
var oldScale = new THREE.Vector3();
var oldRotationMatrix = new THREE.Matrix4();
var parentRotationMatrix = new THREE.Matrix4();
var parentScale = new THREE.Vector3();
var worldPosition = new THREE.Vector3();
var worldRotation = new THREE.Euler();
var worldRotationMatrix = new THREE.Matrix4();
var camPosition = new THREE.Vector3();
var camRotation = new THREE.Euler();
var TransformControls = (function (_super) {
    __extends(TransformControls, _super);
    function TransformControls(scene, camera, domElement) {
        var _this = this;
        _super.call(this);
        this.camera = camera;
        this.domElement = domElement;
        this.visible = false;
        this.root = new THREE.Object3D();
        this.externVisible = true;
        this.size = 1;
        this.mode = "translate";
        this.space = "local";
        this.dragging = false;
        this.disabled = true;
        this.gizmo = {
            "translate": new TransformGizmos_1.TransformGizmoTranslate(),
            "rotate": new TransformGizmos_1.TransformGizmoRotate(),
            "scale": new TransformGizmos_1.TransformGizmoScale(),
            "resize": new TransformGizmos_1.TransformGizmoResize()
        };
        this.changeEvent = { type: "change", target: null };
        this.mouseDownEvent = { type: "mouseDown", target: null };
        this.mouseUpEvent = { type: "mouseUp", mode: this.mode, target: null };
        this.objectChangeEvent = { type: "objectChange", target: null };
        this.onPointerDown = function (event) {
            if (_this.target == null || _this.dragging || (event.button != null && event.button !== 0))
                return;
            var pointer = event.changedTouches ? event.changedTouches[0] : event;
            if (pointer.button === 0 || pointer.button == null) {
                var intersect = _this.intersectObjects(pointer, _this.gizmo[_this.mode].pickersRoot.children);
                if (intersect != null) {
                    event.preventDefault();
                    event.stopPropagation();
                    _this.dispatchEvent(_this.mouseDownEvent);
                    _this.axis = intersect.object.name;
                    _this.update();
                    eye.copy(camPosition).sub(worldPosition).normalize();
                    _this.gizmo[_this.mode].setActivePlane(_this.axis, eye);
                    var planeIntersect = _this.intersectObjects(pointer, [_this.gizmo[_this.mode].activePlane]);
                    if (planeIntersect != null) {
                        oldPosition.copy(_this.root.position);
                        oldScale.copy(_this.root.scale);
                        oldRotationMatrix.extractRotation(_this.root.matrix);
                        worldRotationMatrix.extractRotation(_this.root.matrixWorld);
                        parentRotationMatrix.extractRotation(_this.root.parent.matrixWorld);
                        parentScale.setFromMatrixScale(tempMatrix.getInverse(_this.root.parent.matrixWorld));
                        offset.copy(planeIntersect.point);
                    }
                }
            }
            _this.dragging = true;
        };
        this.onPointerHover = function (event) {
            if (_this.target == null || _this.dragging || (event.button != null && event.button !== 0))
                return;
            var pointer = event.changedTouches ? event.changedTouches[0] : event;
            var newAxis;
            var intersect = _this.intersectObjects(pointer, _this.gizmo[_this.mode].pickersRoot.children);
            if (intersect != null) {
                newAxis = intersect.object.name;
                event.preventDefault();
            }
            if (_this.axis !== newAxis) {
                _this.axis = newAxis;
                _this.update();
                _this.dispatchEvent(_this.changeEvent);
            }
        };
        this.onPointerMove = function (event) {
            if (_this.target == null || _this.axis == null || !_this.dragging || (event.button != null && event.button !== 0))
                return;
            var pointer = event.changedTouches ? event.changedTouches[0] : event;
            var planeIntersect = _this.intersectObjects(pointer, [_this.gizmo[_this.mode].activePlane]);
            if (planeIntersect == null)
                return;
            event.preventDefault();
            event.stopPropagation();
            point.copy(planeIntersect.point);
            switch (_this.mode) {
                case "translate":
                    {
                        point.sub(offset);
                        point.multiply(parentScale);
                        if (_this.space === "local") {
                            point.applyMatrix4(tempMatrix.getInverse(worldRotationMatrix));
                            if (_this.axis.search("X") === -1)
                                point.x = 0;
                            if (_this.axis.search("Y") === -1)
                                point.y = 0;
                            if (_this.axis.search("Z") === -1)
                                point.z = 0;
                            point.applyMatrix4(oldRotationMatrix);
                            _this.root.position.copy(oldPosition);
                            _this.root.position.add(point);
                        }
                        if (_this.space === "world" || _this.axis.search("XYZ") !== -1) {
                            if (_this.axis.search("X") === -1)
                                point.x = 0;
                            if (_this.axis.search("Y") === -1)
                                point.y = 0;
                            if (_this.axis.search("Z") === -1)
                                point.z = 0;
                            point.applyMatrix4(tempMatrix.getInverse(parentRotationMatrix));
                            _this.root.position.copy(oldPosition);
                            _this.root.position.add(point);
                        }
                        if (_this.translationSnap !== null) {
                            if (_this.space === "local")
                                _this.root.position.sub(worldPosition).applyMatrix4(tempMatrix.getInverse(worldRotationMatrix));
                            if (_this.axis.search("X") !== -1)
                                _this.root.position.x = Math.round(_this.root.position.x / _this.translationSnap) * _this.translationSnap;
                            if (_this.axis.search("Y") !== -1)
                                _this.root.position.y = Math.round(_this.root.position.y / _this.translationSnap) * _this.translationSnap;
                            if (_this.axis.search("Z") !== -1)
                                _this.root.position.z = Math.round(_this.root.position.z / _this.translationSnap) * _this.translationSnap;
                            if (_this.space === "local")
                                _this.root.position.applyMatrix4(worldRotationMatrix).add(worldPosition);
                        }
                    }
                    break;
                case "scale":
                    {
                        point.sub(offset);
                        point.multiply(parentScale);
                        if (_this.axis === "XYZ") {
                            var scale = 1 + ((point.y) / Math.max(oldScale.x, oldScale.y, oldScale.z));
                            _this.root.scale.x = oldScale.x * scale;
                            _this.root.scale.y = oldScale.y * scale;
                            _this.root.scale.z = oldScale.z * scale;
                        }
                        else {
                            point.applyMatrix4(tempMatrix.getInverse(worldRotationMatrix));
                            if (_this.axis === "X")
                                _this.root.scale.x = oldScale.x * (1 + point.x / oldScale.x);
                            if (_this.axis === "Y")
                                _this.root.scale.y = oldScale.y * (1 + point.y / oldScale.y);
                            if (_this.axis === "Z")
                                _this.root.scale.z = oldScale.z * (1 + point.z / oldScale.z);
                        }
                    }
                    break;
                case "resize":
                    {
                        point.sub(offset);
                        point.multiply(parentScale);
                        var multiplier = 16;
                        if (_this.axis === "XYZ") {
                            var scale = 1 + ((point.y) / Math.max(oldScale.x, oldScale.y, oldScale.z) * multiplier);
                            _this.root.scale.x = oldScale.x * scale;
                            _this.root.scale.y = oldScale.y * scale;
                            _this.root.scale.z = oldScale.z * scale;
                        }
                        else {
                            point.applyMatrix4(tempMatrix.getInverse(worldRotationMatrix));
                            if (_this.axis === "X")
                                _this.root.scale.x = oldScale.x * (1 + point.x / oldScale.x * multiplier);
                            if (_this.axis === "Y")
                                _this.root.scale.y = oldScale.y * (1 + point.y / oldScale.y * multiplier);
                            if (_this.axis === "Z")
                                _this.root.scale.z = oldScale.z * (1 + point.z / oldScale.z * multiplier);
                        }
                        _this.root.scale.x = Math.round(Math.max(1, _this.root.scale.x));
                        _this.root.scale.y = Math.round(Math.max(1, _this.root.scale.y));
                        _this.root.scale.z = Math.round(Math.max(1, _this.root.scale.z));
                    }
                    break;
                case "rotate":
                    {
                        point.sub(worldPosition);
                        point.multiply(parentScale);
                        tempVector.copy(offset).sub(worldPosition);
                        tempVector.multiply(parentScale);
                        if (_this.axis === "E") {
                            point.applyMatrix4(tempMatrix.getInverse(lookAtMatrix));
                            tempVector.applyMatrix4(tempMatrix.getInverse(lookAtMatrix));
                            rotation.set(Math.atan2(point.z, point.y), Math.atan2(point.x, point.z), Math.atan2(point.y, point.x));
                            offsetRotation.set(Math.atan2(tempVector.z, tempVector.y), Math.atan2(tempVector.x, tempVector.z), Math.atan2(tempVector.y, tempVector.x));
                            tempQuaternion.setFromRotationMatrix(tempMatrix.getInverse(parentRotationMatrix));
                            quaternionE.setFromAxisAngle(eye, rotation.z - offsetRotation.z);
                            quaternionXYZ.setFromRotationMatrix(worldRotationMatrix);
                            tempQuaternion.multiplyQuaternions(tempQuaternion, quaternionE);
                            tempQuaternion.multiplyQuaternions(tempQuaternion, quaternionXYZ);
                            _this.root.quaternion.copy(tempQuaternion);
                        }
                        else if (_this.axis === "XYZE") {
                            quaternionE.setFromEuler(point.clone().cross(tempVector).normalize()); // rotation axis
                            tempQuaternion.setFromRotationMatrix(tempMatrix.getInverse(parentRotationMatrix));
                            quaternionX.setFromAxisAngle(quaternionE, -point.clone().angleTo(tempVector));
                            quaternionXYZ.setFromRotationMatrix(worldRotationMatrix);
                            tempQuaternion.multiplyQuaternions(tempQuaternion, quaternionX);
                            tempQuaternion.multiplyQuaternions(tempQuaternion, quaternionXYZ);
                            _this.root.quaternion.copy(tempQuaternion);
                        }
                        else if (_this.space === "local") {
                            point.applyMatrix4(tempMatrix.getInverse(worldRotationMatrix));
                            tempVector.applyMatrix4(tempMatrix.getInverse(worldRotationMatrix));
                            rotation.set(Math.atan2(point.z, point.y), Math.atan2(point.x, point.z), Math.atan2(point.y, point.x));
                            offsetRotation.set(Math.atan2(tempVector.z, tempVector.y), Math.atan2(tempVector.x, tempVector.z), Math.atan2(tempVector.y, tempVector.x));
                            quaternionXYZ.setFromRotationMatrix(oldRotationMatrix);
                            if (_this.rotationSnap !== null) {
                                quaternionX.setFromAxisAngle(unitX, Math.round((rotation.x - offsetRotation.x) / _this.rotationSnap) * _this.rotationSnap);
                                quaternionY.setFromAxisAngle(unitY, Math.round((rotation.y - offsetRotation.y) / _this.rotationSnap) * _this.rotationSnap);
                                quaternionZ.setFromAxisAngle(unitZ, Math.round((rotation.z - offsetRotation.z) / _this.rotationSnap) * _this.rotationSnap);
                            }
                            else {
                                quaternionX.setFromAxisAngle(unitX, rotation.x - offsetRotation.x);
                                quaternionY.setFromAxisAngle(unitY, rotation.y - offsetRotation.y);
                                quaternionZ.setFromAxisAngle(unitZ, rotation.z - offsetRotation.z);
                            }
                            if (_this.axis === "X")
                                quaternionXYZ.multiplyQuaternions(quaternionXYZ, quaternionX);
                            if (_this.axis === "Y")
                                quaternionXYZ.multiplyQuaternions(quaternionXYZ, quaternionY);
                            if (_this.axis === "Z")
                                quaternionXYZ.multiplyQuaternions(quaternionXYZ, quaternionZ);
                            _this.root.quaternion.copy(quaternionXYZ);
                        }
                        else if (_this.space === "world") {
                            rotation.set(Math.atan2(point.z, point.y), Math.atan2(point.x, point.z), Math.atan2(point.y, point.x));
                            offsetRotation.set(Math.atan2(tempVector.z, tempVector.y), Math.atan2(tempVector.x, tempVector.z), Math.atan2(tempVector.y, tempVector.x));
                            tempQuaternion.setFromRotationMatrix(tempMatrix.getInverse(parentRotationMatrix));
                            if (_this.rotationSnap !== null) {
                                quaternionX.setFromAxisAngle(unitX, Math.round((rotation.x - offsetRotation.x) / _this.rotationSnap) * _this.rotationSnap);
                                quaternionY.setFromAxisAngle(unitY, Math.round((rotation.y - offsetRotation.y) / _this.rotationSnap) * _this.rotationSnap);
                                quaternionZ.setFromAxisAngle(unitZ, Math.round((rotation.z - offsetRotation.z) / _this.rotationSnap) * _this.rotationSnap);
                            }
                            else {
                                quaternionX.setFromAxisAngle(unitX, rotation.x - offsetRotation.x);
                                quaternionY.setFromAxisAngle(unitY, rotation.y - offsetRotation.y);
                                quaternionZ.setFromAxisAngle(unitZ, rotation.z - offsetRotation.z);
                            }
                            quaternionXYZ.setFromRotationMatrix(worldRotationMatrix);
                            if (_this.axis === "X")
                                tempQuaternion.multiplyQuaternions(tempQuaternion, quaternionX);
                            if (_this.axis === "Y")
                                tempQuaternion.multiplyQuaternions(tempQuaternion, quaternionY);
                            if (_this.axis === "Z")
                                tempQuaternion.multiplyQuaternions(tempQuaternion, quaternionZ);
                            tempQuaternion.multiplyQuaternions(tempQuaternion, quaternionXYZ);
                            _this.root.quaternion.copy(tempQuaternion);
                        }
                    }
                    break;
            }
            _this.update(false);
            _this.dispatchEvent(_this.changeEvent);
            _this.dispatchEvent(_this.objectChangeEvent);
        };
        this.onPointerUp = function (event) {
            if (event.button != null && event.button !== 0)
                return;
            if (_this.dragging && (_this.axis !== null)) {
                _this.mouseUpEvent.mode = _this.mode;
                _this.dispatchEvent(_this.mouseUpEvent);
            }
            _this.dragging = false;
            _this.onPointerHover(event);
        };
        scene.add(this);
        scene.add(this.root);
        for (var type in this.gizmo) {
            var gizmoObj = this.gizmo[type];
            gizmoObj.visible = (type === this.mode);
            this.add(gizmoObj);
        }
        this.enable();
    }
    TransformControls.prototype.dispose = function () {
        this.disable();
    };
    TransformControls.prototype.setVisible = function (visible) {
        this.externVisible = visible;
        this.visible = this.externVisible && this.target != null;
        return this;
    };
    TransformControls.prototype.attach = function (object) {
        this.target = object;
        this.visible = this.externVisible;
        this.update();
        return this;
    };
    ;
    TransformControls.prototype.detach = function () {
        this.target = null;
        this.visible = false;
        this.axis = null;
        return this;
    };
    ;
    TransformControls.prototype.getMode = function () { return this.mode; };
    ;
    TransformControls.prototype.setMode = function (mode) {
        this.mode = mode;
        for (var type in this.gizmo)
            this.gizmo[type].visible = (type === mode);
        if (this.target == null)
            return this;
        this.update();
        this.dispatchEvent(this.changeEvent);
        return this;
    };
    ;
    TransformControls.prototype.setSize = function (size) {
        this.size = size;
        if (this.target == null)
            return this;
        this.update();
        this.dispatchEvent(this.changeEvent);
        return this;
    };
    ;
    TransformControls.prototype.setSpace = function (space) {
        this.space = space;
        if (this.target == null)
            return this;
        this.update();
        this.dispatchEvent(this.changeEvent);
        return this;
    };
    ;
    TransformControls.prototype.enable = function () {
        if (!this.disabled)
            return this;
        this.domElement.addEventListener("mousedown", this.onPointerDown, false);
        this.domElement.addEventListener("touchstart", this.onPointerDown, false);
        this.domElement.addEventListener("mousemove", this.onPointerHover, false);
        this.domElement.addEventListener("touchmove", this.onPointerHover, false);
        this.domElement.addEventListener("mousemove", this.onPointerMove, false);
        this.domElement.addEventListener("touchmove", this.onPointerMove, false);
        this.domElement.addEventListener("mouseup", this.onPointerUp, false);
        this.domElement.addEventListener("mouseout", this.onPointerUp, false);
        this.domElement.addEventListener("touchend", this.onPointerUp, false);
        this.domElement.addEventListener("touchcancel", this.onPointerUp, false);
        this.domElement.addEventListener("touchleave", this.onPointerUp, false);
        this.dragging = false;
        this.disabled = false;
        for (var gizmoName in this.gizmo)
            this.gizmo[gizmoName].setDisabled(false);
        return this;
    };
    TransformControls.prototype.disable = function () {
        if (this.disabled)
            return this;
        this.domElement.removeEventListener("mousedown", this.onPointerDown);
        this.domElement.removeEventListener("touchstart", this.onPointerDown);
        this.domElement.removeEventListener("mousemove", this.onPointerHover);
        this.domElement.removeEventListener("touchmove", this.onPointerHover);
        this.domElement.removeEventListener("mousemove", this.onPointerMove);
        this.domElement.removeEventListener("touchmove", this.onPointerMove);
        this.domElement.removeEventListener("mouseup", this.onPointerUp);
        this.domElement.removeEventListener("mouseout", this.onPointerUp);
        this.domElement.removeEventListener("touchend", this.onPointerUp);
        this.domElement.removeEventListener("touchcancel", this.onPointerUp);
        this.domElement.removeEventListener("touchleave", this.onPointerUp);
        this.dragging = false;
        this.disabled = true;
        for (var gizmoName in this.gizmo)
            this.gizmo[gizmoName].setDisabled(true);
        return this;
    };
    TransformControls.prototype.update = function (copyTarget) {
        if (copyTarget === void 0) { copyTarget = true; }
        if (this.target == null)
            return;
        if (copyTarget) {
            this.root.position.copy(this.target.getWorldPosition());
            this.root.quaternion.copy(this.target.getWorldQuaternion());
            var geometry = this.target.geometry;
            var width = (geometry != null && geometry.parameters.width != null) ? geometry.parameters.width : 1;
            var height = (geometry != null && geometry.parameters.height != null) ? geometry.parameters.height : 1;
            var depth = (geometry != null && geometry.parameters.depth != null) ? geometry.parameters.depth : 1;
            if (this.mode === "resize") {
                this.root.scale.x = Math.abs(width);
                this.root.scale.y = Math.abs(height);
                this.root.scale.z = Math.abs(depth);
            }
            else {
                this.root.scale.x = (width < 0 ? -1 : 1) * this.target.scale.x;
                this.root.scale.y = (height < 0 ? -1 : 1) * this.target.scale.y;
                this.root.scale.z = (depth < 0 ? -1 : 1) * this.target.scale.z;
            }
        }
        this.root.updateMatrixWorld(false);
        worldPosition.setFromMatrixPosition(this.root.matrixWorld);
        // NOTE: Workaround for negative scales messing with extracted rotation — elisee
        var scaleX = this.root.scale.x / Math.abs(this.root.scale.x);
        var scaleY = this.root.scale.y / Math.abs(this.root.scale.y);
        var scaleZ = this.root.scale.z / Math.abs(this.root.scale.z);
        var negativeScaleFixMatrix = new THREE.Matrix4().makeScale(scaleX, scaleY, scaleZ);
        worldRotation.setFromRotationMatrix(tempMatrix.extractRotation(this.root.matrixWorld).multiply(negativeScaleFixMatrix));
        this.camera.updateMatrixWorld(false);
        camPosition.setFromMatrixPosition(this.camera.matrixWorld);
        camRotation.setFromRotationMatrix(tempMatrix.extractRotation(this.camera.matrixWorld));
        var scale = worldPosition.distanceTo(camPosition) / 8 * this.size;
        this.position.copy(worldPosition);
        this.scale.set(scale, scale, scale);
        eye.copy(camPosition).sub(worldPosition).normalize();
        if (this.space === "local" || this.mode === "scale" || this.mode === "resize")
            this.gizmo[this.mode].update(worldRotation, eye);
        else if (this.space === "world")
            this.gizmo[this.mode].update(new THREE.Euler(), eye);
        if (!this.disabled)
            this.gizmo[this.mode].highlight(this.axis);
        this.updateMatrixWorld(true);
    };
    ;
    TransformControls.prototype.intersectObjects = function (pointer, objects) {
        var rect = this.domElement.getBoundingClientRect();
        var x = (pointer.clientX - rect.left) / rect.width;
        var y = (pointer.clientY - rect.top) / rect.height;
        pointerVector.set((x * 2) - 1, -(y * 2) + 1);
        ray.setFromCamera(pointerVector, this.camera);
        var intersections = ray.intersectObjects(objects, true);
        return intersections[0];
    };
    return TransformControls;
}(THREE.Object3D));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = TransformControls;

},{"./TransformGizmos":4}],4:[function(require,module,exports){
"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var lineRadius = 0.015;
var colors = {
    white: { enabled: 0xffffff, disabled: 0xffffff },
    red: { enabled: 0xe5432e, disabled: 0x646464 },
    green: { enabled: 0x5bd72f, disabled: 0xb0b0b0 },
    blue: { enabled: 0x3961d4, disabled: 0x606060 },
    yellow: { enabled: 0xffff00, disabled: 0xececec },
    cyan: { enabled: 0x00ffff, disabled: 0xc8c8c8 },
    magenta: { enabled: 0xff00ff, disabled: 0x484848 }
};
var GizmoMaterial = (function (_super) {
    __extends(GizmoMaterial, _super);
    function GizmoMaterial(parameters) {
        _super.call(this, parameters);
        this.transparent = true;
        this.setValues(parameters);
        this.enabledColor = this.color.clone();
        this.disabledColor = this.color.clone();
        this.oldOpacity = this.opacity;
    }
    GizmoMaterial.prototype.setColor = function (colorName) {
        this.color.setHex(colors[colorName].enabled);
        this.enabledColor.setHex(colors[colorName].enabled);
        this.disabledColor.setHex(colors[colorName].disabled);
    };
    GizmoMaterial.prototype.highlight = function (highlighted) {
        if (highlighted) {
            this.color.setRGB(1, 1, 0);
            this.opacity = 1;
        }
        else {
            this.color.copy(this.enabledColor);
            this.opacity = this.oldOpacity;
        }
    };
    GizmoMaterial.prototype.setDisabled = function (disabled) {
        this.color.copy(disabled ? this.disabledColor : this.enabledColor);
    };
    return GizmoMaterial;
}(THREE.MeshBasicMaterial));
var pickerMaterial = new GizmoMaterial({ visible: false, transparent: false });
var TransformGizmo = (function (_super) {
    __extends(TransformGizmo, _super);
    function TransformGizmo() {
        _super.call(this);
        this.planes = {};
        this.handlesRoot = new THREE.Object3D();
        this.pickersRoot = new THREE.Object3D();
        this.planesRoot = new THREE.Object3D();
        this.add(this.handlesRoot);
        this.add(this.pickersRoot);
        this.add(this.planesRoot);
        // Planes
        var planeGeometry = new THREE.PlaneBufferGeometry(50, 50, 2, 2);
        var planeMaterial = new THREE.MeshBasicMaterial({ visible: false, side: THREE.DoubleSide });
        var planes = {
            "XY": new THREE.Mesh(planeGeometry, planeMaterial),
            "YZ": new THREE.Mesh(planeGeometry, planeMaterial),
            "XZ": new THREE.Mesh(planeGeometry, planeMaterial),
            "XYZE": new THREE.Mesh(planeGeometry, planeMaterial)
        };
        this.activePlane = planes["XYZE"];
        planes["YZ"].rotation.set(0, Math.PI / 2, 0);
        planes["XZ"].rotation.set(-Math.PI / 2, 0, 0);
        for (var planeName in planes) {
            planes[planeName].name = planeName;
            this.planesRoot.add(planes[planeName]);
            this.planes[planeName] = planes[planeName];
        }
        // Handles and Pickers
        this.initGizmos();
        // Reset Transformations
        this.traverse(function (child) {
            child.layers.set(1);
            if (child instanceof THREE.Mesh) {
                child.updateMatrix();
                var tempGeometry = child.geometry.clone();
                tempGeometry.applyMatrix(child.matrix);
                child.geometry = tempGeometry;
                child.position.set(0, 0, 0);
                child.rotation.set(0, 0, 0);
                child.scale.set(1, 1, 1);
            }
        });
    }
    ;
    TransformGizmo.prototype.highlight = function (axis) {
        this.traverse(function (child) {
            if (child.material != null && child.material.highlight != null) {
                child.material.highlight(child.name === axis);
            }
        });
    };
    ;
    TransformGizmo.prototype.setDisabled = function (disabled) {
        this.traverse(function (child) {
            if (child.material != null && child.material.setDisabled != null) {
                child.material.setDisabled(disabled);
            }
        });
    };
    TransformGizmo.prototype.setupGizmo = function (name, object, parent, position, rotation, colorName) {
        object.name = name;
        if (position != null)
            object.position.set(position[0], position[1], position[2]);
        if (rotation != null)
            object.rotation.set(rotation[0], rotation[1], rotation[2]);
        if (colorName != null)
            object.material.setColor(colorName);
        parent.add(object);
    };
    TransformGizmo.prototype.update = function (rotation, eye) {
        var vec1 = new THREE.Vector3(0, 0, 0);
        var vec2 = new THREE.Vector3(0, 1, 0);
        var lookAtMatrix = new THREE.Matrix4();
        this.traverse(function (child) {
            if (child.name.search("E") !== -1) {
                child.quaternion.setFromRotationMatrix(lookAtMatrix.lookAt(eye, vec1, vec2));
            }
            else if (child.name.search("X") !== -1 || child.name.search("Y") !== -1 || child.name.search("Z") !== -1) {
                child.quaternion.setFromEuler(rotation);
            }
        });
    };
    return TransformGizmo;
}(THREE.Object3D));
exports.TransformGizmo = TransformGizmo;
var TransformGizmoTranslate = (function (_super) {
    __extends(TransformGizmoTranslate, _super);
    function TransformGizmoTranslate() {
        _super.apply(this, arguments);
    }
    TransformGizmoTranslate.prototype.initGizmos = function () {
        // Handles
        var geometry = new THREE.CylinderGeometry(0, 0.06, 0.2, 12, 1, false);
        var mesh = new THREE.Mesh(geometry);
        mesh.position.y = 0.5;
        mesh.updateMatrix();
        var arrowGeometry = new THREE.Geometry();
        arrowGeometry.merge(geometry, mesh.matrix);
        var lineGeometry = new THREE.CylinderGeometry(lineRadius, lineRadius, 1);
        this.setupGizmo("X", new THREE.Mesh(arrowGeometry, new GizmoMaterial()), this.handlesRoot, [0.5, 0, 0], [0, 0, -Math.PI / 2], "red");
        this.setupGizmo("X", new THREE.Mesh(lineGeometry, new GizmoMaterial()), this.handlesRoot, [0.5, 0, 0], [0, 0, -Math.PI / 2], "red");
        this.setupGizmo("Y", new THREE.Mesh(arrowGeometry, new GizmoMaterial()), this.handlesRoot, [0, 0.5, 0], null, "green");
        this.setupGizmo("Y", new THREE.Mesh(lineGeometry, new GizmoMaterial()), this.handlesRoot, [0, 0.5, 0], null, "green");
        this.setupGizmo("Z", new THREE.Mesh(arrowGeometry, new GizmoMaterial()), this.handlesRoot, [0, 0, 0.5], [Math.PI / 2, 0, 0], "blue");
        this.setupGizmo("Z", new THREE.Mesh(lineGeometry, new GizmoMaterial()), this.handlesRoot, [0, 0, 0.5], [Math.PI / 2, 0, 0], "blue");
        var handlePlaneGeometry = new THREE.PlaneBufferGeometry(0.29, 0.29);
        this.setupGizmo("XY", new THREE.Mesh(handlePlaneGeometry, new GizmoMaterial({ opacity: 0.5 })), this.handlesRoot, [0.15, 0.15, 0], null, "yellow");
        this.setupGizmo("YZ", new THREE.Mesh(handlePlaneGeometry, new GizmoMaterial({ opacity: 0.5 })), this.handlesRoot, [0, 0.15, 0.15], [0, Math.PI / 2, 0], "cyan");
        this.setupGizmo("XZ", new THREE.Mesh(handlePlaneGeometry, new GizmoMaterial({ opacity: 0.5 })), this.handlesRoot, [0.15, 0, 0.15], [-Math.PI / 2, 0, 0], "magenta");
        this.setupGizmo("XYZ", new THREE.Mesh(new THREE.OctahedronGeometry(0.1, 0), new GizmoMaterial({ opacity: 0.8 })), this.handlesRoot, [0, 0, 0], [0, 0, 0], "white");
        // Pickers
        this.setupGizmo("X", new THREE.Mesh(new THREE.CylinderGeometry(0.2, 0, 1, 4, 1, false), pickerMaterial), this.pickersRoot, [0.6, 0, 0], [0, 0, -Math.PI / 2]);
        this.setupGizmo("Y", new THREE.Mesh(new THREE.CylinderGeometry(0.2, 0, 1, 4, 1, false), pickerMaterial), this.pickersRoot, [0, 0.6, 0]);
        this.setupGizmo("Z", new THREE.Mesh(new THREE.CylinderGeometry(0.2, 0, 1, 4, 1, false), pickerMaterial), this.pickersRoot, [0, 0, 0.6], [Math.PI / 2, 0, 0]);
        this.setupGizmo("XY", new THREE.Mesh(new THREE.PlaneBufferGeometry(0.4, 0.4), pickerMaterial), this.pickersRoot, [0.2, 0.2, 0]);
        this.setupGizmo("YZ", new THREE.Mesh(new THREE.PlaneBufferGeometry(0.4, 0.4), pickerMaterial), this.pickersRoot, [0, 0.2, 0.2], [0, Math.PI / 2, 0]);
        this.setupGizmo("XZ", new THREE.Mesh(new THREE.PlaneBufferGeometry(0.4, 0.4), pickerMaterial), this.pickersRoot, [0.2, 0, 0.2], [-Math.PI / 2, 0, 0]);
        this.setupGizmo("XYZ", new THREE.Mesh(new THREE.OctahedronGeometry(0.2, 0), pickerMaterial), this.pickersRoot);
    };
    TransformGizmoTranslate.prototype.setActivePlane = function (axis, eye) {
        var tempMatrix = new THREE.Matrix4();
        eye.applyMatrix4(tempMatrix.getInverse(tempMatrix.extractRotation(this.planes["XY"].matrixWorld)));
        switch (axis) {
            case "X":
                if (Math.abs(eye.y) > Math.abs(eye.z))
                    this.activePlane = this.planes["XZ"];
                else
                    this.activePlane = this.planes["XY"];
                break;
            case "Y":
                if (Math.abs(eye.x) > Math.abs(eye.z))
                    this.activePlane = this.planes["YZ"];
                else
                    this.activePlane = this.planes["XY"];
                break;
            case "Z":
                if (Math.abs(eye.x) > Math.abs(eye.y))
                    this.activePlane = this.planes["YZ"];
                else
                    this.activePlane = this.planes["XZ"];
                break;
            case "XYZ":
                this.activePlane = this.planes["XYZE"];
                break;
            case "XY":
            case "YZ":
            case "XZ":
                this.activePlane = this.planes[axis];
                break;
        }
    };
    ;
    return TransformGizmoTranslate;
}(TransformGizmo));
exports.TransformGizmoTranslate = TransformGizmoTranslate;
var TransformGizmoRotate = (function (_super) {
    __extends(TransformGizmoRotate, _super);
    function TransformGizmoRotate() {
        _super.apply(this, arguments);
    }
    TransformGizmoRotate.prototype.initGizmos = function () {
        var radius = 0.7;
        var globalRadius = radius * 1.2;
        // Handles
        var ringGeometry = new THREE.TorusGeometry(radius, lineRadius, 4, 32);
        this.setupGizmo("X", new THREE.Mesh(ringGeometry, new GizmoMaterial({ side: THREE.DoubleSide })), this.handlesRoot, null, [0, -Math.PI / 2, -Math.PI / 2], "red");
        this.setupGizmo("Y", new THREE.Mesh(ringGeometry, new GizmoMaterial({ side: THREE.DoubleSide })), this.handlesRoot, null, [Math.PI / 2, 0, 0], "green");
        this.setupGizmo("Z", new THREE.Mesh(ringGeometry, new GizmoMaterial({ side: THREE.DoubleSide })), this.handlesRoot, null, [0, 0, -Math.PI / 2], "blue");
        var globalRingGeometry = new THREE.RingGeometry(globalRadius - lineRadius, globalRadius + lineRadius, 32, 8);
        this.setupGizmo("E", new THREE.Mesh(globalRingGeometry, new GizmoMaterial({ opacity: 0.8, side: THREE.DoubleSide })), this.handlesRoot, null, null, "white");
        // Pickers
        var pickerThickness = 0.08;
        var torusGeometry = new THREE.TorusGeometry(radius, lineRadius * 2, 4, 16);
        this.setupGizmo("X", new THREE.Mesh(torusGeometry, pickerMaterial), this.pickersRoot, null, [0, -Math.PI / 2, -Math.PI / 2]);
        this.setupGizmo("Y", new THREE.Mesh(torusGeometry, pickerMaterial), this.pickersRoot, null, [Math.PI / 2, 0, 0]);
        this.setupGizmo("Z", new THREE.Mesh(torusGeometry, pickerMaterial), this.pickersRoot, null, [0, 0, -Math.PI / 2]);
        var globalTorusGeometry = new THREE.RingGeometry(globalRadius - pickerThickness, globalRadius + pickerThickness, 16, 8);
        this.setupGizmo("E", new THREE.Mesh(globalTorusGeometry, pickerMaterial), this.pickersRoot);
    };
    TransformGizmoRotate.prototype.setActivePlane = function (axis) {
        if (axis === "X")
            this.activePlane = this.planes["YZ"];
        else if (axis === "Y")
            this.activePlane = this.planes["XZ"];
        else if (axis === "Z")
            this.activePlane = this.planes["XY"];
        else if (axis === "E")
            this.activePlane = this.planes["XYZE"];
    };
    return TransformGizmoRotate;
}(TransformGizmo));
exports.TransformGizmoRotate = TransformGizmoRotate;
var TransformGizmoScale = (function (_super) {
    __extends(TransformGizmoScale, _super);
    function TransformGizmoScale() {
        _super.apply(this, arguments);
    }
    TransformGizmoScale.prototype.initGizmos = function () {
        // Handles
        var geometry = new THREE.BoxGeometry(0.125, 0.125, 0.125);
        var mesh = new THREE.Mesh(geometry);
        mesh.position.y = 0.5;
        mesh.updateMatrix();
        var arrowGeometry = new THREE.Geometry();
        arrowGeometry.merge(geometry, mesh.matrix);
        var lineGeometry = new THREE.CylinderGeometry(lineRadius, lineRadius, 1);
        this.setupGizmo("X", new THREE.Mesh(arrowGeometry, new GizmoMaterial()), this.handlesRoot, [0.5, 0, 0], [0, 0, -Math.PI / 2], "red");
        this.setupGizmo("X", new THREE.Mesh(lineGeometry, new GizmoMaterial()), this.handlesRoot, [0.5, 0, 0], [0, 0, -Math.PI / 2], "red");
        this.setupGizmo("Y", new THREE.Mesh(arrowGeometry, new GizmoMaterial()), this.handlesRoot, [0, 0.5, 0], null, "green");
        this.setupGizmo("Y", new THREE.Mesh(lineGeometry, new GizmoMaterial()), this.handlesRoot, [0, 0.5, 0], null, "green");
        this.setupGizmo("Z", new THREE.Mesh(arrowGeometry, new GizmoMaterial()), this.handlesRoot, [0, 0, 0.5], [Math.PI / 2, 0, 0], "blue");
        this.setupGizmo("Z", new THREE.Mesh(lineGeometry, new GizmoMaterial()), this.handlesRoot, [0, 0, 0.5], [Math.PI / 2, 0, 0], "blue");
        this.setupGizmo("XYZ", new THREE.Mesh(new THREE.OctahedronGeometry(0.1, 0), new GizmoMaterial({ opacity: 0.8 })), this.handlesRoot, [0, 0, 0], [0, 0, 0], "white");
        // Pickers
        this.setupGizmo("X", new THREE.Mesh(new THREE.CylinderGeometry(0.2, 0, 1, 4, 1, false), pickerMaterial), this.pickersRoot, [0.6, 0, 0], [0, 0, -Math.PI / 2]);
        this.setupGizmo("Y", new THREE.Mesh(new THREE.CylinderGeometry(0.2, 0, 1, 4, 1, false), pickerMaterial), this.pickersRoot, [0, 0.6, 0]);
        this.setupGizmo("Z", new THREE.Mesh(new THREE.CylinderGeometry(0.2, 0, 1, 4, 1, false), pickerMaterial), this.pickersRoot, [0, 0, 0.6], [Math.PI / 2, 0, 0]);
        this.setupGizmo("XYZ", new THREE.Mesh(new THREE.BoxGeometry(0.4, 0.4, 0.4), pickerMaterial), this.pickersRoot);
    };
    TransformGizmoScale.prototype.setActivePlane = function (axis, eye) {
        var tempMatrix = new THREE.Matrix4();
        eye.applyMatrix4(tempMatrix.getInverse(tempMatrix.extractRotation(this.planes["XY"].matrixWorld)));
        if (axis === "X") {
            if (Math.abs(eye.y) > Math.abs(eye.z))
                this.activePlane = this.planes["XZ"];
            else
                this.activePlane = this.planes["XY"];
        }
        else if (axis === "Y") {
            if (Math.abs(eye.x) > Math.abs(eye.z))
                this.activePlane = this.planes["YZ"];
            else
                this.activePlane = this.planes["XY"];
        }
        else if (axis === "Z") {
            if (Math.abs(eye.x) > Math.abs(eye.y))
                this.activePlane = this.planes["YZ"];
            else
                this.activePlane = this.planes["XZ"];
        }
        else if (axis === "XYZ")
            this.activePlane = this.planes["XYZE"];
    };
    return TransformGizmoScale;
}(TransformGizmo));
exports.TransformGizmoScale = TransformGizmoScale;
var TransformGizmoResize = (function (_super) {
    __extends(TransformGizmoResize, _super);
    function TransformGizmoResize() {
        _super.apply(this, arguments);
    }
    TransformGizmoResize.prototype.initGizmos = function () {
        // Handles
        var geometry = new THREE.BoxGeometry(0.2, 0.03, 0.2);
        var mesh = new THREE.Mesh(geometry);
        mesh.position.y = 0.5;
        mesh.updateMatrix();
        var arrowGeometry = new THREE.Geometry();
        arrowGeometry.merge(geometry, mesh.matrix);
        var lineGeometry = new THREE.CylinderGeometry(lineRadius, lineRadius, 1);
        this.setupGizmo("X", new THREE.Mesh(arrowGeometry, new GizmoMaterial()), this.handlesRoot, [0.5, 0, 0], [0, 0, -Math.PI / 2], "red");
        this.setupGizmo("X", new THREE.Mesh(lineGeometry, new GizmoMaterial()), this.handlesRoot, [0.5, 0, 0], [0, 0, -Math.PI / 2], "red");
        this.setupGizmo("Y", new THREE.Mesh(arrowGeometry, new GizmoMaterial()), this.handlesRoot, [0, 0.5, 0], null, "green");
        this.setupGizmo("Y", new THREE.Mesh(lineGeometry, new GizmoMaterial()), this.handlesRoot, [0, 0.5, 0], null, "green");
        this.setupGizmo("Z", new THREE.Mesh(arrowGeometry, new GizmoMaterial()), this.handlesRoot, [0, 0, 0.5], [Math.PI / 2, 0, 0], "blue");
        this.setupGizmo("Z", new THREE.Mesh(lineGeometry, new GizmoMaterial()), this.handlesRoot, [0, 0, 0.5], [Math.PI / 2, 0, 0], "blue");
        this.setupGizmo("XYZ", new THREE.Mesh(new THREE.OctahedronGeometry(0.1, 0), new GizmoMaterial({ opacity: 0.8 })), this.handlesRoot, [0, 0, 0], [0, 0, 0], "white");
        // Pickers
        this.setupGizmo("X", new THREE.Mesh(new THREE.CylinderGeometry(0.2, 0, 1, 4, 1, false), pickerMaterial), this.pickersRoot, [0.6, 0, 0], [0, 0, -Math.PI / 2]);
        this.setupGizmo("Y", new THREE.Mesh(new THREE.CylinderGeometry(0.2, 0, 1, 4, 1, false), pickerMaterial), this.pickersRoot, [0, 0.6, 0]);
        this.setupGizmo("Z", new THREE.Mesh(new THREE.CylinderGeometry(0.2, 0, 1, 4, 1, false), pickerMaterial), this.pickersRoot, [0, 0, 0.6], [Math.PI / 2, 0, 0]);
        this.setupGizmo("XYZ", new THREE.Mesh(new THREE.BoxGeometry(0.4, 0.4, 0.4), pickerMaterial), this.pickersRoot);
    };
    TransformGizmoResize.prototype.setActivePlane = function (axis, eye) {
        var tempMatrix = new THREE.Matrix4();
        eye.applyMatrix4(tempMatrix.getInverse(tempMatrix.extractRotation(this.planes["XY"].matrixWorld)));
        if (axis === "X") {
            if (Math.abs(eye.y) > Math.abs(eye.z))
                this.activePlane = this.planes["XZ"];
            else
                this.activePlane = this.planes["XY"];
        }
        else if (axis === "Y") {
            if (Math.abs(eye.x) > Math.abs(eye.z))
                this.activePlane = this.planes["YZ"];
            else
                this.activePlane = this.planes["XY"];
        }
        else if (axis === "Z") {
            if (Math.abs(eye.x) > Math.abs(eye.y))
                this.activePlane = this.planes["YZ"];
            else
                this.activePlane = this.planes["XZ"];
        }
        else if (axis === "XYZ")
            this.activePlane = this.planes["XYZE"];
    };
    return TransformGizmoResize;
}(TransformGizmo));
exports.TransformGizmoResize = TransformGizmoResize;

},{}],5:[function(require,module,exports){
"use strict";
var TransformMarker = (function () {
    function TransformMarker(root) {
        var geometry = new THREE.Geometry();
        geometry.vertices.push(new THREE.Vector3(-0.25, 0, 0), new THREE.Vector3(0.25, 0, 0), new THREE.Vector3(0, -0.25, 0), new THREE.Vector3(0, 0.25, 0), new THREE.Vector3(0, 0, -0.25), new THREE.Vector3(0, 0, 0.25));
        this.line = new THREE.LineSegments(geometry, new THREE.LineBasicMaterial({ color: 0xffffff, opacity: 0.25, transparent: true }));
        this.line.layers.set(1);
        root.add(this.line);
        this.line.updateMatrixWorld(false);
    }
    TransformMarker.prototype.move = function (target) {
        this.line.visible = true;
        this.line.position.copy(target.getWorldPosition());
        this.line.quaternion.copy(target.getWorldQuaternion());
        this.line.updateMatrixWorld(false);
        return this;
    };
    TransformMarker.prototype.hide = function () {
        this.line.visible = false;
        return this;
    };
    return TransformMarker;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = TransformMarker;

},{}],6:[function(require,module,exports){
(function (global){
"use strict";
var GridHelper_1 = require("./GridHelper");
var SelectionBoxRenderer_1 = require("./SelectionBoxRenderer");
var TransformControls_1 = require("./TransformControls");
var TransformMarker_1 = require("./TransformMarker");
global.SupTHREE.GridHelper = GridHelper_1.default;
global.SupTHREE.SelectionBoxRenderer = SelectionBoxRenderer_1.default;
global.SupTHREE.TransformControls = TransformControls_1.default;
global.SupTHREE.TransformMarker = TransformMarker_1.default;

}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{"./GridHelper":1,"./SelectionBoxRenderer":2,"./TransformControls":3,"./TransformMarker":5}]},{},[6]);
