"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var ArcadeBody2DConfig = (function (_super) {
    __extends(ArcadeBody2DConfig, _super);
    function ArcadeBody2DConfig(pub) {
        _super.call(this, pub, ArcadeBody2DConfig.schema);
    }
    ArcadeBody2DConfig.create = function () {
        var newConfig = {
            formatVersion: ArcadeBody2DConfig.currentFormatVersion,
            type: "box",
            movable: true,
            width: 1,
            height: 1,
            offset: { x: 0, y: 0 },
            tileMapAssetId: null,
            tileSetPropertyName: null,
            layersIndex: null,
        };
        return newConfig;
    };
    ArcadeBody2DConfig.migrate = function (pub) {
        if (pub.formatVersion === ArcadeBody2DConfig.currentFormatVersion)
            return false;
        if (pub.formatVersion == null) {
            pub.formatVersion = 1;
            // Migration v0.12.0
            if (pub.offset == null) {
                pub.offset = { x: pub.offsetX, y: pub.offsetY };
                delete pub.offsetX;
                delete pub.offsetY;
            }
            if (pub.tileMapAssetId === "")
                pub.tileMapAssetId = null;
            // Migration v0.6.0
            if (pub.type == null) {
                pub.type = "box";
                pub.tileMapAssetId = null;
                pub.tileSetPropertyName = null;
                pub.layersIndex = null;
            }
        }
        return true;
    };
    ArcadeBody2DConfig.schema = {
        formatVersion: { type: "integer" },
        type: { type: "enum", items: ["box", "tileMap"], mutable: true },
        // Box
        movable: { type: "boolean", mutable: true },
        width: { type: "number", mutable: true },
        height: { type: "number", mutable: true },
        offset: {
            type: "hash",
            properties: {
                x: { type: "number", mutable: true },
                y: { type: "number", mutable: true },
            }
        },
        // TileMap
        tileMapAssetId: { type: "string?", mutable: true },
        tileSetPropertyName: { type: "string?", mutable: true },
        layersIndex: { type: "string?", min: 0, mutable: true },
    };
    ArcadeBody2DConfig.currentFormatVersion = 1;
    return ArcadeBody2DConfig;
}(SupCore.Data.Base.ComponentConfig));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = ArcadeBody2DConfig;
