"use strict";
function loadAsset(player, entry, callback) {
    player.getAssetData("assets/" + entry.storagePath + "/asset.json", "json", function (err, data) {
        if (data.isBitmap) {
            var img_1 = new Image();
            img_1.onload = function () {
                data.texture = new SupEngine.THREE.Texture(img_1);
                data.texture.needsUpdate = true;
                if (data.filtering === "pixelated") {
                    data.texture.magFilter = SupEngine.THREE.NearestFilter;
                    data.texture.minFilter = SupEngine.THREE.NearestFilter;
                }
                callback(null, data);
            };
            img_1.onerror = function () { callback(null, data); };
            img_1.src = player.dataURL + "assets/" + entry.storagePath + "/bitmap.dat";
        }
        else {
            data.name = "Font" + entry.id;
            var font = void 0;
            try {
                font = new FontFace(data.name, "url(" + player.dataURL + "assets/" + fixedEncodeURIComponent(entry.storagePath) + "/font.dat)");
                document.fonts.add(font);
            }
            catch (e) { }
            if (font != null)
                font.load().then(function () { callback(null, data); }, function () { callback(null, data); });
            else
                callback(null, data);
        }
    });
}
exports.loadAsset = loadAsset;
function fixedEncodeURIComponent(str) {
    return encodeURIComponent(str).replace(/[!'()*]/g, function (c) {
        return "%" + c.charCodeAt(0).toString(16);
    });
}
function createOuterAsset(player, asset) { return new window.Sup.Font(asset); }
exports.createOuterAsset = createOuterAsset;
