"use strict";
var ProjectSettingsEditor = (function () {
    function ProjectSettingsEditor(container, projectClient) {
        var _this = this;
        this.fields = {};
        this.projectClient = projectClient;
        // Vacuum
        {
            var vacuumContainer = document.createElement("div");
            container.appendChild(vacuumContainer);
            var button_1 = document.createElement("button");
            button_1.style.marginRight = "0.5em";
            button_1.textContent = SupClient.i18n.t("settingsEditors:Project.deleteTrashedAssetsFromDisk");
            vacuumContainer.appendChild(button_1);
            var span_1 = document.createElement("span");
            vacuumContainer.appendChild(span_1);
            button_1.addEventListener("click", function (event) {
                button_1.disabled = true;
                _this.projectClient.socket.emit("vacuum:project", function (err, deletedCount) {
                    button_1.disabled = false;
                    if (err != null) {
                        new SupClient.Dialogs.InfoDialog(err);
                        return;
                    }
                    if (deletedCount > 0) {
                        if (deletedCount > 1)
                            span_1.textContent = SupClient.i18n.t("settingsEditors:Project.severalFoldersRemoved", { folders: deletedCount.toString() });
                        else
                            span_1.textContent = SupClient.i18n.t("settingsEditors:Project.oneFolderRemoved");
                    }
                    else
                        span_1.textContent = SupClient.i18n.t("settingsEditors:Project.noFoldersRemoved");
                });
            });
        }
    }
    return ProjectSettingsEditor;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = ProjectSettingsEditor;
