"use strict";
var SceneSettingsEditor = (function () {
    function SceneSettingsEditor(container, projectClient) {
        var _this = this;
        this.fields = {};
        this.onResourceReceived = function (resourceId, resource) {
            _this.resource = resource;
            for (var setting in resource.pub) {
                if (setting === "formatVersion")
                    continue;
                _this.fields[setting].value = resource.pub[setting];
            }
        };
        this.onResourceEdited = function (resourceId, command, propertyName) {
            _this.fields[propertyName].value = _this.resource.pub[propertyName];
        };
        this.projectClient = projectClient;
        var tbody = SupClient.table.createTable(container).tbody;
        var defaultCameraModeRow = SupClient.table.appendRow(tbody, SupClient.i18n.t("settingsEditors:Scene.defaultCameraMode"));
        this.fields["defaultCameraMode"] = SupClient.table.appendSelectBox(defaultCameraModeRow.valueCell, { "3D": "3D", "2D": "2D" });
        this.fields["defaultCameraMode"].addEventListener("change", function (event) {
            _this.projectClient.editResource("sceneSettings", "setProperty", "defaultCameraMode", event.target.value);
        });
        var defaultVerticalAxisRow = SupClient.table.appendRow(tbody, SupClient.i18n.t("settingsEditors:Scene.defaultCameraVerticalAxis"));
        this.fields["defaultVerticalAxis"] = SupClient.table.appendSelectBox(defaultVerticalAxisRow.valueCell, { "Y": "Y", "Z": "Z" });
        this.fields["defaultVerticalAxis"].addEventListener("change", function (event) {
            _this.projectClient.editResource("sceneSettings", "setProperty", "defaultVerticalAxis", event.target.value);
        });
        this.projectClient.subResource("sceneSettings", this);
    }
    return SceneSettingsEditor;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = SceneSettingsEditor;
