"use strict";
var SpriteSettingsEditor = (function () {
    function SpriteSettingsEditor(container, projectClient) {
        var _this = this;
        this.fields = {};
        this.onResourceReceived = function (resourceId, resource) {
            _this.resource = resource;
            for (var setting in resource.pub) {
                _this.fields[setting].value = resource.pub[setting];
            }
        };
        this.onResourceEdited = function (resourceId, command, propertyName) {
            _this.fields[propertyName].value = _this.resource.pub[propertyName];
        };
        this.projectClient = projectClient;
        var tbody = SupClient.table.createTable(container).tbody;
        this.filteringRow = SupClient.table.appendRow(tbody, SupClient.i18n.t("settingsEditors:Sprite.filtering"));
        this.fields["filtering"] = SupClient.table.appendSelectBox(this.filteringRow.valueCell, {
            pixelated: SupClient.i18n.t("settingsEditors:Sprite.pixelated"),
            smooth: SupClient.i18n.t("settingsEditors:Sprite.smooth")
        });
        this.fpsRow = SupClient.table.appendRow(tbody, SupClient.i18n.t("settingsEditors:Sprite.framesPerSecond"));
        this.fields["framesPerSecond"] = SupClient.table.appendNumberField(this.fpsRow.valueCell, "");
        this.pixelsPerUnitRow = SupClient.table.appendRow(tbody, SupClient.i18n.t("settingsEditors:Sprite.pixelsPerUnit"));
        this.fields["pixelsPerUnit"] = SupClient.table.appendNumberField(this.pixelsPerUnitRow.valueCell, "");
        this.alphaTestRow = SupClient.table.appendRow(tbody, SupClient.i18n.t("settingsEditors:Sprite.alphaTesting"));
        this.fields["alphaTest"] = SupClient.table.appendNumberField(this.alphaTestRow.valueCell, "");
        this.fields["filtering"].addEventListener("change", function (event) {
            _this.projectClient.editResource("spriteSettings", "setProperty", "filtering", event.target.value);
        });
        this.fields["framesPerSecond"].addEventListener("change", function (event) {
            _this.projectClient.editResource("spriteSettings", "setProperty", "framesPerSecond", parseInt(event.target.value, 10));
        });
        this.fields["pixelsPerUnit"].addEventListener("change", function (event) {
            _this.projectClient.editResource("spriteSettings", "setProperty", "pixelsPerUnit", parseInt(event.target.value, 10));
        });
        this.fields["alphaTest"].addEventListener("change", function (event) {
            _this.projectClient.editResource("spriteSettings", "setProperty", "alphaTest", parseFloat(event.target.value));
        });
        this.projectClient.subResource("spriteSettings", this);
    }
    return SpriteSettingsEditor;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = SpriteSettingsEditor;
