(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
"use strict";
var TileMapRendererEditor = (function () {
    function TileMapRendererEditor(tbody, config, projectClient, editConfig) {
        var _this = this;
        this.onChangeTileSetAsset = function (event) {
            if (event.target.value === "")
                _this.editConfig("setProperty", "tileSetAssetId", null);
            else {
                var entry = SupClient.findEntryByPath(_this.projectClient.entries.pub, event.target.value);
                if (entry != null && entry.type === "tileSet")
                    _this.editConfig("setProperty", "tileSetAssetId", entry.id);
            }
        };
        this.projectClient = projectClient;
        this.editConfig = editConfig;
        this.tbody = tbody;
        this.tileMapAssetId = config.tileMapAssetId;
        this.tileSetAssetId = config.tileSetAssetId;
        this.shaderAssetId = config.shaderAssetId;
        var tileMapRow = SupClient.table.appendRow(tbody, SupClient.i18n.t("componentEditors:TileMapRenderer.tileMap"));
        this.tileMapFieldSubscriber = SupClient.table.appendAssetField(tileMapRow.valueCell, this.tileMapAssetId, "tileMap", projectClient);
        this.tileMapFieldSubscriber.on("select", function (assetId) {
            _this.editConfig("setProperty", "tileMapAssetId", assetId);
        });
        var tileSetRow = SupClient.table.appendRow(tbody, SupClient.i18n.t("componentEditors:TileMapRenderer.tileSet"));
        this.tileSetTextField = SupClient.table.appendTextField(tileSetRow.valueCell, "");
        this.tileSetTextField.disabled = true;
        this.tileSetTextField.addEventListener("input", this.onChangeTileSetAsset);
        var shadowRow = SupClient.table.appendRow(tbody, SupClient.i18n.t("componentEditors:TileMapRenderer.shadow.title"));
        var shadowDiv = document.createElement("div");
        shadowDiv.classList.add("inputs");
        shadowRow.valueCell.appendChild(shadowDiv);
        var castSpan = document.createElement("span");
        castSpan.style.marginLeft = "5px";
        castSpan.textContent = SupClient.i18n.t("componentEditors:TileMapRenderer.shadow.cast");
        shadowDiv.appendChild(castSpan);
        this.castShadowField = SupClient.table.appendBooleanField(shadowDiv, config.castShadow);
        this.castShadowField.addEventListener("change", function (event) {
            _this.editConfig("setProperty", "castShadow", event.target.checked);
        });
        var receiveSpan = document.createElement("span");
        receiveSpan.style.marginLeft = "5px";
        receiveSpan.textContent = SupClient.i18n.t("componentEditors:TileMapRenderer.shadow.receive");
        shadowDiv.appendChild(receiveSpan);
        this.receiveShadowField = SupClient.table.appendBooleanField(shadowDiv, config.receiveShadow);
        this.receiveShadowField.addEventListener("change", function (event) {
            _this.editConfig("setProperty", "receiveShadow", event.target.checked);
        });
        var materialRow = SupClient.table.appendRow(tbody, SupClient.i18n.t("componentEditors:TileMapRenderer.material"));
        this.materialSelectBox = SupClient.table.appendSelectBox(materialRow.valueCell, { "basic": "Basic", "phong": "Phong", "shader": "Shader" }, config.materialType);
        this.materialSelectBox.addEventListener("change", function (event) {
            _this.editConfig("setProperty", "materialType", event.target.value);
        });
        var shaderRow = SupClient.table.appendRow(tbody, SupClient.i18n.t("componentEditors:TileMapRenderer.shader"));
        this.shaderRow = shaderRow.row;
        this.shaderFieldSubscriber = SupClient.table.appendAssetField(shaderRow.valueCell, this.shaderAssetId, "shader", projectClient);
        this.shaderFieldSubscriber.on("select", function (assetId) {
            _this.editConfig("setProperty", "shaderAssetId", assetId);
        });
        this.shaderRow.hidden = config.materialType !== "shader";
    }
    TileMapRendererEditor.prototype.destroy = function () {
        this.tileMapFieldSubscriber.destroy();
        this.shaderFieldSubscriber.destroy();
    };
    TileMapRendererEditor.prototype.config_setProperty = function (path, value) {
        if (this.projectClient.entries == null)
            return;
        switch (path) {
            case "tileMapAssetId":
                this.tileMapAssetId = value;
                this.tileMapFieldSubscriber.onChangeAssetId(this.tileMapAssetId);
                break;
            case "tileSetAssetId":
                this.tileSetAssetId = value;
                if (this.tileSetAssetId != null)
                    this.tileSetTextField.value = this.projectClient.entries.getPathFromId(this.tileSetAssetId);
                else
                    this.tileSetTextField.value = "";
                break;
            case "castShadow":
                this.castShadowField.checked = value;
                break;
            case "receiveShadow":
                this.receiveShadowField.checked = value;
                break;
            case "materialType":
                this.materialSelectBox.value = value;
                this.shaderRow.hidden = value !== "shader";
                break;
            case "shaderAssetId":
                this.shaderAssetId = value;
                this.shaderFieldSubscriber.onChangeAssetId(this.shaderAssetId);
                break;
        }
    };
    return TileMapRendererEditor;
}());
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = TileMapRendererEditor;

},{}],2:[function(require,module,exports){
"use strict";
function importActor(entry, projectClient, options, callback) {
    var name = entry.name;
    if (name === "Tile Map") {
        var parentNode = projectClient.entries.parentNodesById[entry.id];
        if (parentNode != null)
            name = parentNode.name;
    }
    projectClient.editAsset(SupClient.query.asset, "addNode", name, options, function (nodeId) {
        importComponent(entry, projectClient, nodeId, function (err) { callback(err, nodeId); });
    });
}
exports.importActor = importActor;
function importComponent(entry, projectClient, nodeId, callback) {
    projectClient.editAsset(SupClient.query.asset, "addComponent", nodeId, "TileMapRenderer", null, function (componentId) {
        projectClient.editAsset(SupClient.query.asset, "editComponent", nodeId, componentId, "setProperty", "tileMapAssetId", entry.id, callback);
    });
}
exports.importComponent = importComponent;

},{}],3:[function(require,module,exports){
/// <reference path="../../scene/componentEditors/ComponentEditorPlugin.d.ts" />
/// <reference path="../../scene/componentEditors/ImportIntoScenePlugin.d.ts" />
"use strict";
var TileMapRendererEditor_1 = require("./TileMapRendererEditor");
var importTileMapIntoScene = require("./importTileMapIntoScene");
SupClient.registerPlugin("componentEditors", "TileMapRenderer", TileMapRendererEditor_1.default);
SupClient.registerPlugin("importIntoScene", "tileMap", importTileMapIntoScene);

},{"./TileMapRendererEditor":1,"./importTileMapIntoScene":2}]},{},[3]);
